diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index 6b2ed0a73..f75ee716b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -2,8 +2,6 @@ package net.minecraft.client.render.terrain;
 
 import static org.lwjgl.opengl.GL15.*;
 
-import java.nio.ByteBuffer;
-import java.nio.ByteOrder;
 import java.util.ArrayList;
 import java.util.List;
 
@@ -12,6 +10,7 @@ import com.mojang.logging.LogUtils;
 import org.lwjgl.opengl.GL31;
 
 import net.minecraft.client.render.OpenGLHelper;
+import org.lwjgl.opengl.GL41;
 
 /**
  * 		A large buffer that contains vertex data
@@ -21,6 +20,7 @@ import net.minecraft.client.render.OpenGLHelper;
 public class VertexBuffer {
 	public static final CategorizedLogger LOGGER = LogUtils.getLogger();
 	private int vbo;
+	private final int vao;
 	private long capacity;
 	
 	public List<Entry> entries = new ArrayList<>();
@@ -29,10 +29,11 @@ public class VertexBuffer {
 	
 	public VertexBuffer(long initialCapacity) {
 		this.capacity = initialCapacity;
-		
-		vbo = glGenBuffers();
-		glBindBuffer(GL_ARRAY_BUFFER, vbo);
-		glBufferData(GL_ARRAY_BUFFER, capacity, GL_STATIC_DRAW);
+
+        this.vbo = glGenBuffers();
+        this.vao = GL41.glGenVertexArrays();
+		glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
+		glBufferData(GL_ARRAY_BUFFER, this.capacity, GL_STATIC_DRAW);
 		glBindBuffer(GL_ARRAY_BUFFER, 0);
 	}
 	
@@ -42,7 +43,7 @@ public class VertexBuffer {
 		}
 		
 		// If the buffer is empty, just put it at the start
-		if(entries.size() == 0) {
+		if(this.entries.isEmpty()) {
 			return insertAtIndex(vertexData, 0);
 		}
 		
@@ -50,8 +51,8 @@ public class VertexBuffer {
 		
 		// If there is a single element in the buffer, check if there is enough space in front of it
 		// If not put it behind the other element
-		if(entries.size() == 1) {
-			Entry entry = entries.get(0);
+		if(this.entries.size() == 1) {
+			Entry entry = this.entries.get(0);
 			if(entry.position > bytes) {
 				return insertAtIndex(vertexData, 0);
 			}else {
@@ -60,9 +61,9 @@ public class VertexBuffer {
 		}
 		
 		// Check between every single element for a large enough gap
-		for(int i = 0; i < entries.size() - 1; i++) {
-			Entry entry = entries.get(i);
-			Entry nextEntry = entries.get(i + 1);
+		for(int i = 0; i < this.entries.size() - 1; i++) {
+			Entry entry = this.entries.get(i);
+			Entry nextEntry = this.entries.get(i + 1);
 			
 			int availableSpace = nextEntry.position - (entry.position + entry.size);
 			if(availableSpace > bytes) {
@@ -71,7 +72,7 @@ public class VertexBuffer {
 		}
 		
 		// Put it all the way at the end
-		return insertAtIndex(vertexData, entries.size());
+		return insertAtIndex(vertexData, this.entries.size());
 	}
 	
 	private Entry insertAtIndex(VertexData vertexData, int listIndex) {
@@ -79,24 +80,24 @@ public class VertexBuffer {
 		int bytes = vertexData.buffer.position();
 		
 		if(listIndex > 0) {
-			Entry prev = entries.get(listIndex - 1);
+			Entry prev = this.entries.get(listIndex - 1);
 			pos = prev.position + prev.size;
 		}
 		
-		if(pos + bytes >= capacity) {
+		if(pos + bytes >= this.capacity) {
 			expandVBO();
 		}
 		
 		Entry entry = new Entry(pos, bytes);
 		
 		if(listIndex > 0) {
-			Entry previousEntry = entries.get(listIndex - 1);
+			Entry previousEntry = this.entries.get(listIndex - 1);
 			if(previousEntry.position + previousEntry.size > pos) {
 				throw new RuntimeException("Entry collision: " + entry + " and " + previousEntry);
 			}
 		}
-		if(listIndex < entries.size() - 1) {
-			Entry nextEntry = entries.get(listIndex + 1);
+		if(listIndex < this.entries.size() - 1) {
+			Entry nextEntry = this.entries.get(listIndex + 1);
 			if(nextEntry.position <= pos + bytes) {
 				throw new RuntimeException("Entry collision: " + entry + " and " + nextEntry);
 			}
@@ -104,11 +105,11 @@ public class VertexBuffer {
 		
 		vertexData.buffer.flip();
 		
-		glBindBuffer(GL_ARRAY_BUFFER, vbo);
+		glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
 		glBufferSubData(GL_ARRAY_BUFFER, pos, vertexData.buffer);
 		glBindBuffer(GL_ARRAY_BUFFER, 0);
-		
-		entries.add(listIndex, entry);
+
+        this.entries.add(listIndex, entry);
 		
 		return entry;
 	}
@@ -116,7 +117,7 @@ public class VertexBuffer {
 	private void expandVBO() {
 		final long prevCapacity = this.capacity;
 		long newCapacity = this.capacity * 2L;
-		if(newCapacity < capacity) {
+		if(newCapacity < this.capacity) {
 			// future proof
 			throw new RuntimeException();
 		}
@@ -130,52 +131,35 @@ public class VertexBuffer {
 		glBufferData(GL_ARRAY_BUFFER, newCapacity, GL_STATIC_DRAW);
 		
 		OpenGLHelper.checkError("create expand buffer");
-		
-		if(OpenGLHelper.gl31) {
-			glBindBuffer(GL31.GL_COPY_READ_BUFFER, this.vbo);
-			glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, newBuffer);
-			
-			GL31.glCopyBufferSubData(GL31.GL_COPY_READ_BUFFER, GL31.GL_COPY_WRITE_BUFFER, 0, 0, this.capacity);
-			
-			glBindBuffer(GL31.GL_COPY_READ_BUFFER, 0);
-			glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, 0);	
-		}else {
-			// confirmed to work on trash hardware
-			
-			int iPrevCapacity = (int) prevCapacity;
-			int iNewCapacity = (int) newCapacity;
 
-			if(iPrevCapacity < 0) throw new RuntimeException("Previous capacity < 0");
-			if(iNewCapacity < 0) throw new RuntimeException("New capacity < 0");
-			if(iNewCapacity < iPrevCapacity) throw new RuntimeException("New capacity < previous capacity: " + iNewCapacity + " < " + iPrevCapacity);
-			
-			ByteBuffer oldData = ByteBuffer.allocateDirect(iPrevCapacity).order(ByteOrder.nativeOrder());
-			
-			glBindBuffer(GL_ARRAY_BUFFER, this.vbo);
-			glGetBufferSubData(GL_ARRAY_BUFFER, 0L, oldData);
-			
-			oldData.position(0);
-			
-			glBindBuffer(GL_ARRAY_BUFFER, newBuffer);
-			glBufferSubData(GL_ARRAY_BUFFER, 0L, oldData);
-		}
-		
-		OpenGLHelper.checkError("copy buffer");
+        glBindBuffer(GL31.GL_COPY_READ_BUFFER, this.vbo);
+        glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, newBuffer);
+
+        GL31.glCopyBufferSubData(GL31.GL_COPY_READ_BUFFER, GL31.GL_COPY_WRITE_BUFFER, 0, 0, this.capacity);
+
+        glBindBuffer(GL31.GL_COPY_READ_BUFFER, 0);
+        glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, 0);
+
+        OpenGLHelper.checkError("copy buffer");
 		
 		this.capacity = newCapacity;
 		this.vbo = newBuffer;
 	}
 	
 	public boolean removeEntry(Entry entry) {
-		return entries.remove(entry);
+		return this.entries.remove(entry);
 	}
 	
 	public int getVbo() {
-		return vbo;
+		return this.vbo;
+	}
+
+	public int getVao() {
+		return this.vao;
 	}
 	
 	public int entryCount() {
-		return entries.size();
+		return this.entries.size();
 	}
 	
 	/**
@@ -186,7 +170,7 @@ public class VertexBuffer {
 		public final int position;
 		public final int size;
 		
-		private final int hashCode = entryHashCounter++;
+		private final int hashCode = VertexBuffer.this.entryHashCounter++;
 		
 		public Entry(int position, int size) {
 			this.position = position;
@@ -195,12 +179,12 @@ public class VertexBuffer {
 		
 		@Override
 		public String toString() {
-			return "VertexBufferEntry[position: " + position + ", size: " + size + "]";
+			return "VertexBufferEntry[position: " + this.position + ", size: " + this.size + "]";
 		}
 		
 		@Override
 		public int hashCode() {
-			return hashCode;
+			return this.hashCode;
 		}
 		
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
index 296e48a1d..da09d570e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfig.java
@@ -1,242 +1,12 @@
 package net.minecraft.client.render.terrain;
 
-import static org.lwjgl.opengl.GL20.*;
-
-import java.nio.ByteBuffer;
-import java.util.ArrayList;
-import java.util.List;
-
-import com.b100.json.element.JsonObject;
-
-public class VertexConfig {
-	
-	public int drawMode;
-	public boolean enableColor = false;
-	public boolean enableTexture = false;
-	public boolean enableNormal = false;
-	public boolean enableLightmap = false;
-	public final List<VertexAttribute> attributes = new ArrayList<>();
-	
-	public void enableDirect(ByteBuffer buffer) {
-		int vertexSize = getVertexSize();
-		int offset = 0;
-		
-		buffer.position(offset);
-		glEnableClientState(GL_VERTEX_ARRAY);
-		glVertexPointer(3, GL_FLOAT, vertexSize, buffer);
-		offset += 12;
-		
-		if(enableColor) {
-			buffer.position(offset);
-			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, buffer);
-			glEnableClientState(GL_COLOR_ARRAY);
-			offset += 4;
-		}else {
-			glDisableClientState(GL_COLOR_ARRAY);
-		}
-		
-		if(enableTexture) {
-			buffer.position(offset);
-			glTexCoordPointer(2, GL_FLOAT, vertexSize, buffer);
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			offset += 8;
-		}else {
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-		}
-		
-		if(enableNormal) {
-			buffer.position(offset);
-			glNormalPointer(GL_BYTE, vertexSize, buffer);
-			glEnableClientState(GL_NORMAL_ARRAY);
-			offset += 3;
-		}else {
-			glDisableClientState(GL_NORMAL_ARRAY);
-		}
-		
-		glClientActiveTexture(GL_TEXTURE1);
-		if(enableLightmap) {
-			buffer.position(offset);
-			glTexCoordPointer(2, GL_SHORT, vertexSize, buffer);
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			offset += 4;
-		}else {
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-		}
-		glClientActiveTexture(GL_TEXTURE0);
-		
-		for(int i=0; i < attributes.size(); i++) {
-			VertexAttribute attrib = attributes.get(i);
-			
-			buffer.position(offset);
-			glEnableVertexAttribArray(attrib.id);
-			glVertexAttribPointer(attrib.id, attrib.getSize(), attrib.type, false, vertexSize, buffer);
-			offset += attrib.getTypeSize();
-		}
-	}
-	
-	public void enableVBO(int vbo) {
-		glBindBuffer(GL_ARRAY_BUFFER, vbo);
-		
-		int vertexSize = getVertexSize();
-		int offset = 0;
-		
-		glEnableClientState(GL_VERTEX_ARRAY);
-		glVertexPointer(3, GL_FLOAT, vertexSize, offset);
-		offset += 12;
-		
-		if(enableColor) {
-			glColorPointer(4, GL_UNSIGNED_BYTE, vertexSize, offset);
-			glEnableClientState(GL_COLOR_ARRAY);
-			offset += 4;
-		}else {
-			glDisableClientState(GL_COLOR_ARRAY);
-		}
-		
-		if(enableTexture) {
-			glTexCoordPointer(2, GL_FLOAT, vertexSize, offset);
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			offset += 8;
-		}else {
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-		}
-		
-		if(enableNormal) {
-			glNormalPointer(GL_BYTE, vertexSize, offset);
-			glEnableClientState(GL_NORMAL_ARRAY);
-			offset += 3;
-		}else {
-			glDisableClientState(GL_NORMAL_ARRAY);
-		}
-		
-		if(enableLightmap) {
-			glClientActiveTexture(GL_TEXTURE1);
-			glTexCoordPointer(2, GL_SHORT, vertexSize, offset);
-			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
-			offset += 4;
-			glClientActiveTexture(GL_TEXTURE0);
-		}
-		
-		for(int i=0; i < attributes.size(); i++) {
-			VertexAttribute attrib = attributes.get(i);
-			
-			glEnableVertexAttribArray(attrib.id);
-			glVertexAttribPointer(attrib.id, attrib.getSize(), attrib.type, false, vertexSize, offset);
-			offset += attrib.getTypeSize();
-		}
-	}
-	
-	public void disable() {
-		if(enableLightmap) {
-			glClientActiveTexture(GL_TEXTURE1);
-			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
-			glClientActiveTexture(GL_TEXTURE0);
-		}
-		
-		glBindBuffer(GL_ARRAY_BUFFER, 0);
-		for(int i=0; i < attributes.size(); i++) {
-			VertexAttribute attrib = attributes.get(i);
-			glDisableVertexAttribArray(attrib.id);
-		}
-	}
-	
-	public int getVertexSize() {
-		int size = 12;
-		
-		if(enableColor) size += 4;
-		if(enableTexture) size += 8;
-		if(enableNormal) size += 3;
-		if(enableLightmap) size += 4;
-		
-		for(int i=0; i < attributes.size(); i++) {
-			size += attributes.get(i).getTypeSize();
-		}
-		
-		return size;
-	}
-	
-	public VertexConfig copy() {
-		VertexConfig copy = new VertexConfig();
-		copy.drawMode = drawMode;
-		copy.enableColor = enableColor;
-		copy.enableTexture = enableTexture;
-		copy.enableNormal = enableNormal;
-		copy.enableLightmap = enableLightmap;
-		copy.attributes.addAll(attributes);
-		return copy;
-	}
-	
-	@Override
-	public boolean equals(Object obj) {
-		if(obj instanceof VertexConfig) {
-			return compare(this, (VertexConfig) obj) == 0;
-		}
-		return false;
-	}
-	
-	/**
-	 * Only used for debugging
-	 */
-	public JsonObject toJson() {
-		JsonObject object = new JsonObject();
-		object.set("drawMode", drawMode);
-		object.set("enableColor", enableColor);
-		object.set("enableTexcoord", enableTexture);
-		object.set("enableNormal", enableNormal);
-		object.set("enableLightmap", enableLightmap);
-		if(attributes.size() > 0) {
-			JsonObject attribsJson = new JsonObject();
-			
-			attribsJson.set("size", attributes.size());
-			
-			for(int i=0; i < attributes.size(); i++) {
-				VertexAttribute attribute = attributes.get(i);
-				JsonObject attribObject = new JsonObject();
-				
-				attribObject.set("id", attribute.id);
-				attribObject.set("type", attribute.type);
-				
-				attribsJson.set(attribute.name, attribObject);
-			}
-			
-			object.set("attribs", attribsJson);
-		}
-		return object;
-	}
-	
-	public static int compare(VertexConfig c1, VertexConfig c2) {
-		if(c1.drawMode != c2.drawMode) return 1;
-		if(c1.enableColor != c2.enableColor) return 2;
-		if(c1.enableTexture != c2.enableTexture) return 3;
-		if(c1.enableNormal != c2.enableNormal) return 4;
-		if(c1.enableLightmap != c2.enableLightmap) return 4;
-		
-		if(c1.attributes.size() != c2.attributes.size()) {
-			return 5;
-		}
-		
-		for(int i=0; i < c1.attributes.size(); i++) {
-			VertexAttribute attrib1 = c1.attributes.get(i);
-			VertexAttribute attrib2 = c2.attributes.get(i);
-			int compare = VertexAttribute.compare(attrib1, attrib2); 
-			if(compare != 0) {
-				return (6 + i) * 1000 + compare;
-			}
-		}
-		
-		return 0;
-	}
-	
-	public static void compareThrow(VertexConfig config1, VertexConfig config2) {
-		int compare = compare(config1, config2);
-		if(compare != 0) {
-			System.err.println("VertexConfig Mismatch:\n" + config1 + "\n!=\n" + config2);
-			throw new RuntimeException("VertexConfig mismatch " + compare + "!");
-		}	
-	}
-	
-	@Override
-	public String toString() {
-		return toJson().toString();
-	}
-
+import net.minecraft.client.render.renderer.DrawMode;
+import org.jetbrains.annotations.NotNull;
+
+public interface VertexConfig<T extends VertexConfig<T>> {
+    @NotNull DrawMode drawmode();
+    void enable(int vao, int vbo);
+    void disable();
+    int getVertexSize();
+    @NotNull T copy();
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfigStandard.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfigStandard.java
new file mode 100644
index 000000000..2b514974c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexConfigStandard.java
@@ -0,0 +1,189 @@
+package net.minecraft.client.render.terrain;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import com.b100.json.element.JsonObject;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.tessellator.Tessellator;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+
+public class VertexConfigStandard implements VertexConfig<VertexConfigStandard> {
+	
+	public @NotNull DrawMode drawMode = Tessellator.QUAD_EMULATION ? DrawMode.TRIANGLES : DrawMode.QUADS;
+	public boolean enableColor = false;
+	public boolean enableTexture = false;
+	public boolean enableNormal = false;
+	public boolean enableLightmap = false;
+	public final List<VertexAttribute> attributes = new ArrayList<>();
+
+	@Override
+	public @NotNull DrawMode drawmode() {
+		return this.drawMode;
+	}
+
+	public void enable(int vao, int vbo) {
+		GL41.glBindVertexArray(vao);
+		GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, vbo);
+		
+		int vertexSize = getVertexSize();
+		int offset = 0;
+		GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, vertexSize, offset); offset += 3 * Float.BYTES;    // Pos
+		GL41.glEnableVertexAttribArray(0);
+		if (this.enableColor) {
+			GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 4;    // Color
+			GL41.glEnableVertexAttribArray(1);
+		} else {
+			GL41.glVertexAttrib4f(1, 1f, 1f, 1f, 1f);
+		}
+		if (this.enableTexture) {
+			GL41.glVertexAttribPointer(2, 2, GL41.GL_FLOAT, false, vertexSize, offset); offset += 2 * Float.BYTES;    // UV
+			GL41.glEnableVertexAttribArray(2);
+		}
+		if (this.enableLightmap) {
+			GL41.glVertexAttribPointer(3, 2, GL41.GL_UNSIGNED_BYTE, true, vertexSize, offset); offset += 2;    // Lightmap
+			GL41.glEnableVertexAttribArray(3);
+		} else {
+			GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+		}
+		if (this.enableNormal) {
+			GL41.glVertexAttribPointer(4, 3, GL41.GL_BYTE, true, vertexSize, offset); offset += 3;    // Normal
+			GL41.glEnableVertexAttribArray(4);
+		} else {
+			GL41.glVertexAttrib3f(4, 0, -1, 0);
+		}
+		
+		for(int i = 0; i < this.attributes.size(); i++) {
+			VertexAttribute attrib = this.attributes.get(i);
+			
+			GL41.glEnableVertexAttribArray(attrib.id);
+			GL41.glVertexAttribPointer(attrib.id, attrib.getSize(), attrib.type, false, vertexSize, offset);
+			offset += attrib.getTypeSize();
+		}
+	}
+	
+	public void disable() {
+		GL41.glDisableVertexAttribArray(0);
+		GL41.glDisableVertexAttribArray(1);
+		GL41.glDisableVertexAttribArray(2);
+		GL41.glDisableVertexAttribArray(3);
+		GL41.glDisableVertexAttribArray(4);
+
+		for(int i = 0; i < this.attributes.size(); i++) {
+			VertexAttribute attrib = this.attributes.get(i);
+			GL41.glDisableVertexAttribArray(attrib.id);
+		}
+		GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, 0);
+		GL41.glBindVertexArray(0);
+	}
+	
+	public int getVertexSize() {
+		int size = Float.BYTES * 3;
+		
+		if(this.enableColor) {
+			size += 4;
+		}
+		if(this.enableTexture) {
+			size += Float.BYTES * 2;
+		}
+		if(this.enableNormal) {
+			size += 3;
+		}
+		if(this.enableLightmap) {
+			size += 2;
+		}
+		
+		for(int i = 0; i < this.attributes.size(); i++) {
+			size += this.attributes.get(i).getTypeSize();
+		}
+		
+		return size;
+	}
+	
+	public @NotNull VertexConfigStandard copy() {
+		VertexConfigStandard copy = new VertexConfigStandard();
+		copy.drawMode = this.drawMode;
+		copy.enableColor = this.enableColor;
+		copy.enableTexture = this.enableTexture;
+		copy.enableNormal = this.enableNormal;
+		copy.enableLightmap = this.enableLightmap;
+		copy.attributes.addAll(this.attributes);
+		return copy;
+	}
+	
+	@Override
+	public boolean equals(Object obj) {
+		if(obj instanceof VertexConfigStandard) {
+			return compare(this, (VertexConfigStandard) obj) == 0;
+		}
+		return false;
+	}
+	
+	/**
+	 * Only used for debugging
+	 */
+	public JsonObject toJson() {
+		JsonObject object = new JsonObject();
+		object.set("drawMode", this.drawMode.name());
+		object.set("enableColor", this.enableColor);
+		object.set("enableTexcoord", this.enableTexture);
+		object.set("enableNormal", this.enableNormal);
+		object.set("enableLightmap", this.enableLightmap);
+		if(!this.attributes.isEmpty()) {
+			JsonObject attribsJson = new JsonObject();
+			
+			attribsJson.set("size", this.attributes.size());
+			
+			for(int i = 0; i < this.attributes.size(); i++) {
+				VertexAttribute attribute = this.attributes.get(i);
+				JsonObject attribObject = new JsonObject();
+				
+				attribObject.set("id", attribute.id);
+				attribObject.set("type", attribute.type);
+				
+				attribsJson.set(attribute.name, attribObject);
+			}
+			
+			object.set("attribs", attribsJson);
+		}
+		return object;
+	}
+
+	public static int compare(VertexConfigStandard c1, VertexConfigStandard c2) {
+		if(c1.drawMode != c2.drawMode) return 1;
+		if(c1.enableColor != c2.enableColor) return 2;
+		if(c1.enableTexture != c2.enableTexture) return 3;
+		if(c1.enableNormal != c2.enableNormal) return 4;
+		if(c1.enableLightmap != c2.enableLightmap) return 4;
+
+		if(c1.attributes.size() != c2.attributes.size()) {
+			return 5;
+		}
+
+		for(int i=0; i < c1.attributes.size(); i++) {
+			VertexAttribute attrib1 = c1.attributes.get(i);
+			VertexAttribute attrib2 = c2.attributes.get(i);
+			int compare = VertexAttribute.compare(attrib1, attrib2);
+			if(compare != 0) {
+				return (6 + i) * 1000 + compare;
+			}
+		}
+
+		return 0;
+	}
+
+	public static void compareThrow(VertexConfig<?> config1, VertexConfig<?> config2) {
+		if(!config1.equals(config2)) {
+			System.err.println("VertexConfig Mismatch:\n" + config1 + "\n!=\n" + config2);
+			throw new RuntimeException("VertexConfig mismatch " + config1 + " " + config2 + "!");
+		}
+	}
+
+	@Override
+	public String toString() {
+		return toJson().toString();
+	}
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
index 124c03505..523b0f409 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexData.java
@@ -1,36 +1,18 @@
 package net.minecraft.client.render.terrain;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.nio.ByteBuffer;
 
 import net.minecraft.core.util.helper.Buffer;
 
 public class VertexData {
-	
-	public ByteBuffer buffer;
-	
-	public VertexConfig config = new VertexConfig();
-	
-	public int vertexCount;
-	
-	public VertexData(int size) {
-		buffer = Buffer.createBuffer(size);
-	}
-	
-	public void drawAll() {
-		draw(0, vertexCount);
-	}
-	
-	public void draw(int first, int count) {
-		if(count == 0) {
-			return;
-		}
-		
-		buffer.limit(config.getVertexSize() * vertexCount);
-		config.enableDirect(buffer);
-		glDrawArrays(config.drawMode, first, count);
-		config.disable();
-	}
 
+    public ByteBuffer buffer;
+
+    public VertexConfig<?> config = new VertexConfigStandard();
+
+    public int vertexCount;
+
+    public VertexData(int size) {
+        this.buffer = Buffer.createBuffer(size);
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/RenderBuffer.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/RenderBuffer.java
new file mode 100644
index 000000000..4bfff5c5a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/RenderBuffer.java
@@ -0,0 +1,14 @@
+package net.minecraft.client.render.tessellator;
+
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.client.render.terrain.VertexConfig;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+
+public record RenderBuffer(int vao, int vbo, int offset, int count, @NotNull DrawMode drawMode) {
+
+    public void delete() {
+        GL41.glDeleteBuffers(vbo());
+        GL41.glDeleteVertexArrays(vao());
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
index 63638f71b..da2d5ca78 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/Tessellator.java
@@ -1,28 +1,30 @@
 package net.minecraft.client.render.tessellator;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.renderer.DrawMode;
+import net.minecraft.core.enums.EnumOS;
 import org.jetbrains.annotations.NotNull;
 
 public interface Tessellator {
-	
-    public static @NotNull TessellatorStandard instance = new TessellatorStandard(0x200000);
-    
-    public void draw();
-    public void startDrawingQuads();
-    public void startDrawing(int drawMode);
-    public void setTextureUV(double u, double v);
-    public void setLightmapCoord(int lightmapCoord);
-    public void setColorOpaque_F(float r, float g, float b);
-    public void setColorRGBA_F(float r, float g, float b, float a);
-    public void setColorOpaque(int r, int g, int b);
-    public void setColorRGBA(int r, int g, int b, int a);
-    public void setColorOpaque_I(int rgb);
-    public void setColorRGBA_I(int rgb, int a);
-    public void lockColor();
-    public void addVertexWithUV(double x, double y, double z, double u, double v);
-    public void addVertex(double x, double y, double z);
-    public void setNormal(float x, float y, float z);
-    public void setTranslation(double x, double y, double z);
-    public void offsetTranslation(double x, double y, double z);
-    public void drawRectangle(int x, int y, int width, int height);
-    public void drawRectangleWithUV(int x, int y, int width, int height, double u, double v, double uvWidth, double uvHeight);
+    boolean QUAD_EMULATION = /*Minecraft.getOs() == EnumOS.macos || */true; // I hate you so fucking much apple
+    void startDrawing(@NotNull DrawMode drawMode);
+    @Deprecated
+    default void startDrawingQuads() {
+        startDrawing(DrawMode.QUADS);
+    }
+
+    void addVertex(double x, double y, double z);
+
+    void setTranslation(double x, double y, double z);
+    void offsetTranslation(double x, double y, double z);
+
+    default void drawRectangle(int x, int y, int width, int height) {
+        this.addVertex(x, y, 0.0D);
+        this.addVertex(x, y + height, 0.0D);
+        this.addVertex(x + width, y + height, 0.0D);
+        this.addVertex(x + width, y, 0.0D);
+    }
+
+    void draw();
+    @NotNull RenderBuffer record(int vao, int vbo);
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorBase.java b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorBase.java
index 665b4742d..b2be309a0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorBase.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tessellator/TessellatorBase.java
@@ -1,69 +1,82 @@
 package net.minecraft.client.render.tessellator;
 
-import org.lwjgl.opengl.GL11;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.render.renderer.DrawMode;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.BufferUtils;
+import org.slf4j.Logger;
 
-public abstract class TessellatorBase implements Tessellator {
+import java.nio.ByteBuffer;
 
-    @Override
-    public void addVertexWithUV(double x, double y, double z, double u, double v) {
-        setTextureUV(u, v);
-        addVertex(x, y, z);
-    }
+public abstract class TessellatorBase implements Tessellator{
+    private static final Logger LOGGER = LogUtils.getLogger();
 
-    @Override
-    public void drawRectangle(int x, int y, int width, int height) {
-        this.checkIsDrawing();
-        this.addVertex((double) x, (double) y, 0.0D);
-        this.addVertex((double) x, (double) (y + height), 0.0D);
-        this.addVertex((double) (x + width), (double) (y + height), 0.0D);
-        this.addVertex((double) (x + width), (double) y, 0.0D);
-    }
+    public final @NotNull String name;
+    public @NotNull ByteBuffer data;
 
-    @Override
-    public void drawRectangleWithUV(int x, int y, int width, int height, double u, double v, double uvWidth, double uvHeight) {
-        this.checkIsDrawing();
-        this.addVertexWithUV((double) x, (double) y, 0.0D, u, v);
-        this.addVertexWithUV((double) x, (double) (y + height), 0.0D, u, v + uvHeight);
-        this.addVertexWithUV((double) (x + width), (double) (y + height), 0.0D, u + uvWidth, v + uvHeight);
-        this.addVertexWithUV((double) (x + width), (double) y, 0.0D, u + uvWidth, v);
+    protected double offsetX;
+    protected double offsetY;
+    protected double offsetZ;
+
+    public @NotNull DrawMode drawMode = DrawMode.TRIANGLES;
+    public boolean drawing;
+    public int vertexCount;
+    public TessellatorBase(@NotNull String name, int initialCapacity) {
+        this.name = name;
+        this.data = BufferUtils.createByteBuffer(initialCapacity);
     }
 
     @Override
-    public void setColorOpaque(int r, int g, int b) {
-        this.setColorRGBA(r, g, b, 255);
+    public void startDrawing(@NotNull DrawMode drawMode) {
+        if (this.drawing) {
+            this.drawing = false;
+            throw new IllegalStateException(this.name + "Already drawing!");
+        }
+
+        this.drawMode = drawMode;
+        this.drawing = true;
+        this.vertexCount = 0;
+
+        this.data.clear();
     }
 
     @Override
-    public void setColorOpaque_F(float r, float g, float b) {
-        this.setColorOpaque((int) (r * 255.0F), (int) (g * 255.0F), (int) (b * 255.0F));
+    public void setTranslation(double x, double y, double z) {
+        this.offsetX = x;
+        this.offsetY = y;
+        this.offsetZ = z;
     }
 
     @Override
-    public void setColorOpaque_I(int rgb) {
-        int r = rgb >> 16 & 255;
-        int g = rgb >> 8 & 255;
-        int b = rgb & 255;
-        this.setColorOpaque(r, g, b);
+    public void offsetTranslation(double x, double y, double z) {
+        this.offsetX += x;
+        this.offsetY += y;
+        this.offsetZ += z;
     }
 
-    @Override
-    public void setColorRGBA_F(float r, float g, float b, float a) {
-        this.setColorRGBA((int) (r * 255.0F), (int) (g * 255.0F), (int) (b * 255.0F), (int) (a * 255.0F));
+    public void checkIsDrawing() {
+        if (!this.drawing) {
+            throw new IllegalStateException(this.name + " not drawing!");
+        }
     }
 
-    @Override
-    public void setColorRGBA_I(int rgb, int a) {
-        int r = rgb >> 16 & 255;
-        int g = rgb >> 8 & 255;
-        int b = rgb & 255;
-        this.setColorRGBA(r, g, b, a);
+    public void checkCanFit(int size) {
+        if(this.data.capacity() < this.data.position() + size) {
+            int newSize = this.data.capacity() * 2;
+
+            LOGGER.info("Expanding {} Buffer ({} -> {})", this.name, this.data.capacity(), newSize);
+
+            ByteBuffer newBuffer = BufferUtils.createByteBuffer(newSize);
+            this.data.flip();
+            newBuffer.put(this.data);
+            this.data = newBuffer;
+        }
     }
 
     @Override
-    public void startDrawingQuads() {
-        startDrawing(GL11.GL_QUADS);
-    }
+    public abstract void draw();
 
-    public abstract void checkIsDrawing();
+    @Override
+    public abstract @NotNull RenderBuffer record(int vao, int vbo);
 
 }
